<template>
  <div class="mainmenu__overlay">
    <div class="content">
      <transition name="list">
        <nav v-show="active && !showSubmenu" class="nav">
          <!-- <nuxt-link to="/la-compagnie/">{{ $tr('menu_company') }}</nuxt-link> -->

          <button @click="showSubmenu = 'activeShows'">
            {{ $tr('menu_shows') }}
          </button>

          <button
            v-show="shows && archivedShows.length"
            @click="showSubmenu = 'archivedShows'"
          >
            {{ $tr('menu_archives') }}
          </button>

          <template v-for="page in pages">
            <button
              v-if="page.children.length"
              :key="page.slug"
              @click="showSubmenu = page.name"
            >
              {{ page.name }}
            </button>
            <nuxt-link
              v-if="!page.parent_page && !page.children.length && page.slug"
              :key="page.slug"
              :to="`/${page.slug}`"
            >
              {{ page.name }}
            </nuxt-link>
          </template>
        </nav>
      </transition>

      <!-- submenu -->
      <transition name="list">
        <nav v-if="active && showSubmenu" class="subnav">
          <transition name="fade">
            <button
              v-show="showSubmenu"
              class="back"
              @click="showSubmenu = null"
            >
              <UiCoreVIcon name="west" class="icon" />
              <h2>
                {{ showSubmenu }}
              </h2>
            </button>
          </transition>

          <nuxt-link
            v-for="(submenuEntry, i) in activeSubMenu"
            :key="submenuEntry.slug"
            :to="getSubPagePath(submenuEntry)"
            @mouseover.native="previewShow = i"
            @mouseleave.native="previewShow = null"
            @click.native="
              previewShow = null
              showSubmenu = null
            "
          >
            {{ submenuEntry.name }}
          </nuxt-link>
        </nav>
      </transition>

      <!-- <transition name="fade"> -->
      <UiCoreVProgressCircular v-show="loading" indeterminate x-large />
      <!-- </transition> -->
      <div v-if="showSubmenu" class="hero-bg">
        <div v-show="showSubmenu && previewShow !== null" class="fader" />
        <transition name="bg">
          <ModuleHeroSliderItem
            v-if="
              showSubmenu &&
              previewShow !== null &&
              activeSubMenu[previewShow] &&
              activeSubMenu[previewShow].slides_left
            "
            class="hero-bg__item left"
            :item="activeSubMenu[previewShow].slides_left[0]"
          />
        </transition>
        <transition name="bg">
          <ModuleHeroSliderItem
            v-if="
              showSubmenu &&
              previewShow !== null &&
              activeSubMenu[previewShow] &&
              activeSubMenu[previewShow].slides_right
            "
            class="hero-bg__item right"
            :item="activeSubMenu[previewShow].slides_right[0]"
          />
        </transition>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState } from 'vuex'
export default {
  transition: 'list',
  props: {
    active: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      showSubmenu: null,
      previewShow: null,
      loading: false,
    }
  },
  computed: {
    ...mapState({
      shows: (state) => state.shows.items,
      pages: (state) => state.navigation.pages,
    }),
    activeShows() {
      return this.shows.filter((show) => !show.archived)
    },
    archivedShows() {
      return this.shows.filter((show) => show.archived)
    },

    computedShows() {
      return this.showSubmenu === 'activeShows'
        ? this.shows.filter((show) => !show.archived)
        : this.shows.filter((show) => show.archived)
    },
    activeSubMenu() {
      let submenuEntries

      switch (this.showSubmenu) {
        case 'activeShows':
          submenuEntries = this.activeShows
          break

        case 'archivedShows':
          submenuEntries = this.archivedShows
          break

        default: {
          const parentPage = this.pages.filter((page) => {
            return page.name === this.showSubmenu
          })
          const allSubmenuEntries = parentPage[0].children
          const publishedSubmenuEntries = allSubmenuEntries.filter((page) => {
            return page.status === 'published'
          })
          submenuEntries = publishedSubmenuEntries
          break
        }
      }
      return submenuEntries
    },
  },

  methods: {
    toggleShows(type) {
      this.showSubmenu = type
    },
    getSubPagePath(page) {
      let path
      if (
        this.showSubmenu === 'archivedShows' ||
        this.showSubmenu === 'activeShows'
      )
        path = `/spectacles/${page.slug}`
      else if (page.parent_page) path = `/${page.slug}`

      return path
    },
  },
}
</script>

<style lang="scss" scoped>
// $easing: cubic-bezier(0.87, 0, 0.13, 1); // in out expo
// $easing: cubic-bezier(0.85, 0, 0.15, 1); // in out circ
$easing: cubic-bezier(0.83, 0, 0.17, 1); // in out quint

.mainmenu__overlay {
  @apply fixed inset-0 z-40;

  .content {
    @apply h-screen relative z-50 flex flex-col items-center justify-start mt-32;
    max-height: 100vh;
    overflow-y: auto;
    @screen lg {
      @apply mt-36;
    }

    .nav,
    .subnav {
      @apply text-white  uppercase flex flex-col items-center justify-center mt-4 -ml-3;
      //   animation: 400ms appear;
      transition: opacity 400ms $easing;
      top: 0;
      @screen lg {
        @apply mt-20;
      }
      a,
      button,
      h2 {
        @apply text-xl py-1;
        @screen md {
          @apply py-1;
        }
        @screen lg {
          @apply text-2xl py-0;
        }
      }
      a.nuxt-link-exact-active {
        @apply underline;
      }
    }
    .back {
      transition: opacity 400ms $easing;
    }

    .nav {
      a,
      button {
        @apply mx-4 uppercase italic font-bold text-center;
        transition: all 400ms $easing 300ms;
      }
    }

    .subnav {
      //   animation: 400ms appear;

      h2 {
        @apply mx-4 mb-1 uppercase italic font-bold;

        @screen lg {
          @apply mb-8;
        }
      }
      a,
      button {
        @apply mx-4 uppercase font-light text-center;
        transition: all 400ms $easing 500ms;
      }
      .icon {
        --v-icon-size: 35px;
        @screen lg {
          --v-icon-size: 55px;
        }
      }
    }
  }

  .hero-bg {
    display: none;
    @screen lg {
      display: inherit;
    }
    @apply fixed;
    top: 5vw;
    bottom: 5vw;
    left: 2.5vw;
    right: 2.5vw;
    z-index: -1;

    .fader {
      @apply absolute inset-0 block  z-10;
      background: black;
      opacity: 0.4;
      //   mix-blend-mode: multiply;
    }
    &__item {
      @apply absolute;
      mask-repeat: no-repeat;
      mask-size: 100% 100%;
      margin-left: 0px;
      opacity: 1;
      transition: opacity 800ms $easing;

      :deep(img),
      :deep(section) {
        transition: all 500ms $easing;
      }
      &.left {
        left: 5vw;
        width: 48vw;

        mask-image: url('/SVG/mask-left.svg');
      }

      &.right {
        width: 48vw;
        right: 5vw;
        mask-image: url('/SVG/mask-right.svg');
      }
    }
  }
}

.v-progress-circular {
  --v-progress-circular-color: #000;
  --v-progress-circular-background-color: #fff;
}

.bg-enter, .bg-leave-to
/* .list-leave-active below version 2.1.8 */ {
  &.left {
    :deep(img),
    :deep(section) {
      opacity: 0;
      //   transform: translate(-150px, 100%);
      transform: translateX(100%);
    }
  }

  &.right {
    :deep(img),
    :deep(section) {
      opacity: 0;
      //   transform: translate(150px, -100%);
      transform: translateX(-100%);
    }
  }
}

.bg-leave-active {
  //   position: absolute;
}

.list-enter,
.list-leave-to {
  opacity: 0;
}

.list-enter-active {
  opacity: 0;
}
.list-leave-active {
  position: absolute;
}
@keyframes appear {
  0% {
    opacity: 0;
  }
  80% {
    opacity: 0;
  }
}
</style>
